import java.net.Socket;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;

public class ChatHandler implements Runnable{
	
	ChatServer server;			//  ü
	Socket socket;				// 
	BufferedReader bufReader;	// ۸
	DataInputStream dataIn;		//  Է Ʈ
	Thread listener;			// 
	String clientMsg;			// Ŭ̾Ʈ ޽
	
	// 
	public ChatHandler(ChatServer server, Socket clientSock){
		
		this.server = server;
		socket = clientSock;
		
		try {	
			bufReader = new BufferedReader(new InputStreamReader( new DataInputStream(new BufferedInputStream(socket.getInputStream()))));		
		}catch(IOException e){}
		
		listener = new Thread(this);
		listener.start();	//  
	}
	
	// 
	public void run(){
		while(listener != null){
			try{
				clientMsg = bufReader.readLine();
				
				if(clientMsg.startsWith("NEWCLIENT")){
					server.addClient(socket, clientMsg.substring(10));
				}
				else if(clientMsg.startsWith("LOGGINGOUT")){
					server.removeClient(clientMsg.substring(11));
				}
				else if(clientMsg.startsWith("MESSAGETO")){
					String recepient, message;
					recepient = clientMsg.substring(10,clientMsg.indexOf(" ",10));
					message = clientMsg.substring(clientMsg.indexOf(" ",10)+1);
					server.unicast(server.getClientSocket(recepient),"MESSAGEFROM "+message);
				}
			}catch(IOException e){}
		}
	}
}