
import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

public class ClientListRenderer extends JLabel implements ListCellRenderer{
	
	public ClientListRenderer(){}
	final static ImageIcon iconImage = new ImageIcon("./img/sm_mark.JPG");

     public Component getListCellRendererComponent(
       JList list,              
       Object value,            
       int index,              
       boolean isSelected,      
       boolean cellHasFocus)    
     {
         String s = value.toString();
         setText(s);
         if(index>0){
        	 setIcon(iconImage);
         }
         if (isSelected) {
             setBackground(list.getSelectionBackground());
             setForeground(list.getSelectionForeground());
         } else {
             setBackground(list.getBackground());
             setForeground(list.getForeground());
         }
         setEnabled(list.isEnabled());
         setFont(list.getFont());
         setOpaque(true);
         return this;
     }
 }
