
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class DialogBox implements ActionListener,KeyListener{
	JFrame frame1,frame2;
	JLabel lmessage;
	JButton okButton;

	public DialogBox(JFrame parent,String title,String message){
		frame1=parent;
		frame1.setEnabled(false);
		frame2=new JFrame(title);
		frame2.setLayout(null);
		frame2.setAlwaysOnTop(true);
		frame2.setBounds(800,185,220,150);
		frame2.setResizable(false);
				
		lmessage=new JLabel(message);
		lmessage.setBounds(20,20,200,25);
		frame2.add(lmessage);
		
		okButton=new JButton("okButton");
		okButton.setBounds(80,60,60,40);
		okButton.addActionListener(this);
		okButton.addKeyListener(this);
		frame2.add(okButton);
		
		frame2.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==okButton){
			frame1.setEnabled(true);
			frame2.dispose();
		}
	}
	
	public void keyPressed(KeyEvent e){
		if(e.getKeyChar()=='\n'){
			frame1.setEnabled(true);
			frame2.dispose();
		}
	}
	public void keyReleased(KeyEvent e){}
    public void keyTyped(KeyEvent e){}
}
